/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern15 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode)
      || !const_int_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern27 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ASHIFT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          if (pnum_clobbers == NULL
              || GET_MODE (x6) != E_DImode)
            return -1;
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          if (!general_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!general_operand (operands[2], E_HImode)
              || !
#line 2865 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          *pnum_clobbers = 1;
          return 173; /* subdi_sexthishl32 */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x6;
          if (!general_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x2, 0);
          if (!rtx_equal_p (x7, operands[0]))
            return -1;
          return 174; /* subdi_dishl32 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x5 = XEXP (x1, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern12 (x1, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 1;
              return 175; /* subdi3 */

            case 1:
              if (!
#line 3000 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 178; /* subhi3 */

            case 2:
              if (!
#line 3016 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 180; /* subqi3 */

            case 3:
              if (
#line 3066 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
                return 191; /* subsf3_68881 */
              if (!
#line 3079 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
                return -1;
              return 194; /* subsf3_cf */

            case 4:
              if (
#line 3066 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
                return 192; /* subdf3_68881 */
              if (!
#line 3079 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
                return -1;
              return 195; /* subdf3_cf */

            case 5:
              if (!
#line 3066 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
                return -1;
              return 193; /* subxf3_68881 */

            default:
              return -1;
            }

        case STRICT_LOW_PART:
          x9 = XEXP (x5, 0);
          operands[0] = x9;
          operands[1] = x3;
          x7 = XEXP (x2, 0);
          if (!rtx_equal_p (x7, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !general_src_operand (operands[1], E_HImode)
                  || !
#line 3008 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 179; /* *m68k.md:3004 */

            case E_QImode:
              if (!nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !general_src_operand (operands[1], E_QImode)
                  || !
#line 3024 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 181; /* *m68k.md:3020 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      switch (pattern16 (x2))
        {
        case 0:
          if (general_operand (operands[2], E_SImode)
              && 
#line 3039 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 182; /* subsf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 3048 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 185; /* subsf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 3057 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 188; /* subsf3_floatqi_68881 */

        case 1:
          if (general_operand (operands[2], E_SImode)
              && 
#line 3039 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 183; /* subdf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 3048 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 186; /* subdf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 3057 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 189; /* subdf3_floatqi_68881 */

        case 2:
          if (general_operand (operands[2], E_SImode)
              && 
#line 3039 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 184; /* subxf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 3048 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 187; /* subxf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 3057 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 190; /* subxf3_floatqi_68881 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case STRICT_LOW_PART:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTRACT:
      res = recog_4 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      res = recog_7 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTEND:
      if (GET_MODE (x3) == E_DImode)
        {
          operands[0] = x2;
          if (register_operand (operands[0], E_DImode))
            {
              x4 = XEXP (x3, 0);
              operands[1] = x4;
              switch (GET_MODE (operands[1]))
                {
                case E_QImode:
                  if (nonimmediate_src_operand (operands[1], E_QImode))
                    return 83; /* zero_extendqidi2 */
                  break;

                case E_HImode:
                  if (nonimmediate_src_operand (operands[1], E_HImode))
                    return 84; /* zero_extendhidi2 */
                  break;

                default:
                  break;
                }
            }
        }
      break;

    case SIGN_EXTEND:
      res = recog_8 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_9 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_10 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MULT:
      res = recog_11 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case AND:
      res = recog_12 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      operands[1] = x3;
      if (nonimmediate_operand (operands[0], E_SImode))
        {
          if (general_operand (operands[1], E_SImode)
              && 
#line 1019 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
            return 56; /* *movsi_cf */
          if (pcrel_address (operands[1], E_SImode)
              && 
#line 1072 "../../gcc/config/m68k/m68k.md"
(TARGET_PCREL))
            return 57; /* *m68k.md:1069 */
        }
      if (address_operand (operands[1], E_SImode)
          && push_operand (operands[0], E_SImode))
        return 77; /* pushasi */
      break;

    case PC:
      operands[0] = x3;
      if (address_operand (operands[0], E_SImode))
        return 406; /* indirect_jump */
      break;

    default:
      break;
    }
  operands[0] = x2;
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      res = recog_13 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SIGN_EXTEND:
      res = recog_14 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_15 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      if (GET_MODE (x3) == E_SImode
          && nonimmediate_operand (operands[0], E_SImode))
        {
          switch (pattern19 (x3))
            {
            case 0:
              return 176; /* subsi3 */

            case 1:
              if (
#line 2993 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 177; /* *m68k.md:2988 */
              break;

            default:
              break;
            }
        }
      break;

    case MULT:
      res = recog_16 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case AND:
      res = recog_17 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SUBREG:
      if (known_eq (SUBREG_BYTE (x3), 4)
          && GET_MODE (x3) == E_SImode
          && nonimmediate_operand (operands[0], E_SImode))
        {
          x4 = XEXP (x3, 0);
          if (GET_MODE (x4) == E_DImode)
            {
              switch (GET_CODE (x4))
                {
                case ASHIFTRT:
                  x5 = XEXP (x4, 1);
                  if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 32])
                    {
                      x6 = XEXP (x4, 0);
                      operands[1] = x6;
                      if (general_operand (operands[1], E_DImode))
                        return 319; /* subregsi1ashrdi_const32 */
                    }
                  break;

                case LSHIFTRT:
                  x5 = XEXP (x4, 1);
                  if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 32])
                    {
                      x6 = XEXP (x4, 0);
                      operands[1] = x6;
                      if (general_operand (operands[1], E_DImode))
                        return 330; /* subreg1lshrdi_const32 */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      break;

    default:
      break;
    }
  if (!nonimmediate_operand (operands[0], E_SImode))
    return -1;
  operands[1] = x3;
  if (!address_operand (operands[1], E_QImode))
    return -1;
  return 407; /* *lea */
}
