/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern4 (x3, 
E_SImode); /* [-1, 0] */

    case E_HImode:
      if (pattern4 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_QImode:
      if (pattern4 (x3, 
E_QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern13 (x1, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern13 (x1, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_XFmode:
      if (pattern13 (x1, 
E_XFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (XWINT (x3, 0) == 1L)
    {
      x4 = XEXP (x2, 2);
      if (GET_CODE (x4) == MINUS
          && GET_MODE (x4) == E_SImode)
        {
          x5 = XEXP (x4, 0);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 7]
              && memory_operand (operands[0], E_QImode))
            {
              x6 = XEXP (x4, 1);
              switch (GET_CODE (x6))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case MEM:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[1] = x6;
                  if (general_operand (operands[1], E_SImode))
                    return 359; /* bclrmemqi */
                  break;

                case SIGN_EXTEND:
                case ZERO_EXTEND:
                  operands[2] = x6;
                  if (extend_operator (operands[2], E_SImode))
                    {
                      x7 = XEXP (x6, 0);
                      operands[1] = x7;
                      if (general_operand (operands[1], E_VOIDmode))
                        return 360; /* *bclrmemqi_ext */
                    }
                  break;

                default:
                  break;
                }
            }
        }
    }
  operands[1] = x3;
  if (!const_int_operand (operands[1], E_SImode)
      || !register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 2);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_SImode)
      || !
#line 5717 "../../gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD && IN_RANGE (INTVAL (operands[2]), 0, 31)))
    return -1;
  return 375; /* *insv_bfclr_reg */
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!nonimmediate_src_operand (operands[2], E_HImode))
            return -1;
          return 197; /* mulhisi3 */

        case CONST_INT:
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_SImode)
              || !
#line 3119 "../../gcc/config/m68k/m68k.md"
(INTVAL (operands[2]) >= -0x8000 && INTVAL (operands[2]) <= 0x7fff))
            return -1;
          return 198; /* *mulhisisi3_s */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      if (!general_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (general_src_operand (operands[2], E_SImode)
          && 
#line 3138 "../../gcc/config/m68k/m68k.md"
(TARGET_68020))
        return 199; /* *mulsi3_68020 */
      if (!general_operand (operands[2], E_SImode)
          || !
#line 3147 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
        return -1;
      return 200; /* *mulsi3_cf */

    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!nonimmediate_src_operand (operands[2], E_HImode))
            return -1;
          return 201; /* umulhisi3 */

        case CONST_INT:
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_SImode)
              || !
#line 3170 "../../gcc/config/m68k/m68k.md"
(INTVAL (operands[2]) >= 0 && INTVAL (operands[2]) <= 0xffff))
            return -1;
          return 202; /* *mulhisisi3_z */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (memory_src_operand (operands[1], E_QImode)
      && XWINT (x3, 0) == 32L)
    {
      x5 = XEXP (x2, 2);
      operands[2] = x5;
      if (const_int_operand (operands[2], E_SImode)
          && 
#line 5521 "../../gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD
   && (INTVAL (operands[2]) % 8) == 0
   && ! mode_dependent_address_p (XEXP (operands[1], 0),
                                  MEM_ADDR_SPACE (operands[1]))))
        return 363; /* *extzv_32_mem */
    }
  if (!register_operand (operands[1], E_SImode))
    return -1;
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  if (
#line 5537 "../../gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD
   && IN_RANGE (INTVAL (operands[3]), 0, 31)
   && (INTVAL (operands[2]) == 8 || INTVAL (operands[2]) == 16)
   && INTVAL (operands[3]) % INTVAL (operands[2]) == 0))
    return 364; /* *extzv_8_16_reg */
  if (!
#line 5707 "../../gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD && IN_RANGE (INTVAL (operands[3]), 0, 31)))
    return -1;
  return 374; /* *extv_bfextu_reg */
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern1 (x1))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_DImode
              || !general_operand (operands[1], E_DImode))
            return -1;
          if (
#line 3971 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return 273; /* negdi2_internal */
          if (!
#line 3988 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
            return -1;
          return 274; /* negdi2_5200 */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_SImode
              || !general_operand (operands[1], E_SImode))
            return -1;
          if (
#line 4009 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return 275; /* negsi2_internal */
          if (!
#line 4017 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
            return -1;
          return 276; /* negsi2_5200 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_HImode
              || !general_operand (operands[1], E_HImode)
              || !
#line 4025 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 277; /* neghi2 */

        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_QImode
              || !general_operand (operands[1], E_QImode)
              || !
#line 4039 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 279; /* negqi2 */

        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_SFmode
              || !general_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 4146 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 281; /* negsf2_68881 */
          if (!
#line 4161 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 284; /* negsf2_cf */

        case E_DFmode:
          if (!nonimmediate_operand (operands[0], E_DFmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_DFmode
              || !general_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 4146 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 282; /* negdf2_68881 */
          if (!
#line 4161 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 285; /* negdf2_cf */

        case E_XFmode:
          if (!nonimmediate_operand (operands[0], E_XFmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_XFmode
              || !general_operand (operands[1], E_XFmode)
              || !
#line 4146 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 283; /* negxf2_68881 */

        default:
          return -1;
        }

    case 1:
      if (!
#line 4032 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
        return -1;
      return 278; /* *m68k.md:4029 */

    case 2:
      if (!
#line 4046 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
        return -1;
      return 280; /* *m68k.md:4043 */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      return recog_32 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != PC)
            return -1;
          switch (GET_CODE (x3))
            {
            case NE:
            case EQ:
              res = recog_19 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          if (ordered_comparison_operator (x3, E_VOIDmode))
            {
              res = recog_20 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[0] = x3;
          if (!comparison_operator (operands[0], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          x7 = XEXP (x2, 1);
          switch (GET_CODE (x7))
            {
            case LABEL_REF:
              x8 = XEXP (x2, 2);
              if (GET_CODE (x8) != PC)
                return -1;
              x9 = XEXP (x7, 0);
              operands[3] = x9;
              switch (pattern25 ())
                {
                case 0:
                  if (
#line 745 "../../gcc/config/m68k/m68k.md"
(TARGET_68881
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode)
       || const0_operand (operands[2], SFmode))))
                    return 32; /* cbranchsf4_insn_68881 */
                  if (!
#line 763 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode)
       || const0_operand (operands[2], SFmode))))
                    return -1;
                  return 35; /* cbranchsf4_insn_cf */

                case 1:
                  if (
#line 745 "../../gcc/config/m68k/m68k.md"
(TARGET_68881
   && (register_operand (operands[1], DFmode)
       || register_operand (operands[2], DFmode)
       || const0_operand (operands[2], DFmode))))
                    return 33; /* cbranchdf4_insn_68881 */
                  if (!
#line 763 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU
   && (register_operand (operands[1], DFmode)
       || register_operand (operands[2], DFmode)
       || const0_operand (operands[2], DFmode))))
                    return -1;
                  return 36; /* cbranchdf4_insn_cf */

                case 2:
                  if ((
#line 745 "../../gcc/config/m68k/m68k.md"
(TARGET_68881
   && (register_operand (operands[1], XFmode)
       || register_operand (operands[2], XFmode)
       || const0_operand (operands[2], XFmode))) && 
#line 278 "../../gcc/config/m68k/m68k.md"
(TARGET_68881)))
                    return 34; /* cbranchxf4_insn_68881 */
                  if (!(
#line 763 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU
   && (register_operand (operands[1], XFmode)
       || register_operand (operands[2], XFmode)
       || const0_operand (operands[2], XFmode))) && 
#line 278 "../../gcc/config/m68k/m68k.md"
(TARGET_68881)))
                    return -1;
                  return 37; /* cbranchxf4_insn_cf */

                default:
                  return -1;
                }

            case PC:
              x8 = XEXP (x2, 2);
              if (GET_CODE (x8) != LABEL_REF)
                return -1;
              x10 = XEXP (x8, 0);
              operands[3] = x10;
              switch (pattern25 ())
                {
                case 0:
                  if (
#line 781 "../../gcc/config/m68k/m68k.md"
(TARGET_68881
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode)
       || const0_operand (operands[2], SFmode))))
                    return 38; /* cbranchsf4_insn_rev_68881 */
                  if (!
#line 799 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode)
       || const0_operand (operands[2], SFmode))))
                    return -1;
                  return 41; /* cbranchsf4_insn_rev_cf */

                case 1:
                  if (
#line 781 "../../gcc/config/m68k/m68k.md"
(TARGET_68881
   && (register_operand (operands[1], DFmode)
       || register_operand (operands[2], DFmode)
       || const0_operand (operands[2], DFmode))))
                    return 39; /* cbranchdf4_insn_rev_68881 */
                  if (!
#line 799 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU
   && (register_operand (operands[1], DFmode)
       || register_operand (operands[2], DFmode)
       || const0_operand (operands[2], DFmode))))
                    return -1;
                  return 42; /* cbranchdf4_insn_rev_cf */

                case 2:
                  if ((
#line 781 "../../gcc/config/m68k/m68k.md"
(TARGET_68881
   && (register_operand (operands[1], XFmode)
       || register_operand (operands[2], XFmode)
       || const0_operand (operands[2], XFmode))) && 
#line 278 "../../gcc/config/m68k/m68k.md"
(TARGET_68881)))
                    return 40; /* cbranchxf4_insn_rev_68881 */
                  if (!(
#line 799 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU
   && (register_operand (operands[1], XFmode)
       || register_operand (operands[2], XFmode)
       || const0_operand (operands[2], XFmode))) && 
#line 278 "../../gcc/config/m68k/m68k.md"
(TARGET_68881)))
                    return -1;
                  return 43; /* cbranchxf4_insn_rev_cf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_QImode))
        {
          res = recog_22 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !ordered_comparison_operator (x2, E_VOIDmode))
        return -1;
      operands[1] = x2;
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      if (!general_operand (operands[2], E_DImode))
        return -1;
      x7 = XEXP (x2, 1);
      if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          if (
#line 5755 "../../gcc/config/m68k/m68k.md"
(! TARGET_COLDFIRE))
            return 378; /* scc0_di */
          if (
#line 5764 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
            return 379; /* scc0_di_5200 */
        }
      operands[3] = x7;
      if (!general_operand (operands[3], E_DImode))
        return -1;
      if (
#line 5774 "../../gcc/config/m68k/m68k.md"
(! TARGET_COLDFIRE))
        return 380; /* scc_di */
      if (!
#line 5784 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
        return -1;
      return 381; /* scc_di_5200 */

    case TRUNCATE:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode)
            return -1;
          if (general_src_operand (operands[1], E_SImode)
              && 
#line 1632 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return 78; /* truncsiqi2 */
          if (!general_src_operand (operands[1], E_HImode)
              || !
#line 1650 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 79; /* trunchiqi2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !general_src_operand (operands[1], E_SImode)
              || !
#line 1673 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 80; /* truncsihi2 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!nonimmediate_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !general_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 2013 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 100; /* *m68k.md:2009 */
          if (!
#line 2039 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 101; /* extendsfdf2_cf */

        case E_XFmode:
          if (!nonimmediate_operand (operands[0], E_XFmode)
              || GET_MODE (x2) != E_XFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!general_operand (operands[1], E_SFmode)
                  || !
#line 6524 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
                return -1;
              return 408; /* extendsfxf2 */

            case E_DFmode:
              if (!general_operand (operands[1], E_DFmode)
                  || !
#line 6553 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
                return -1;
              return 409; /* extenddfxf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!general_operand (operands[1], E_DFmode))
                return -1;
              if (
#line 2067 "../../gcc/config/m68k/m68k.md"
(TARGET_68881 && TARGET_68040))
                return 102; /* *m68k.md:2063 */
              if (
#line 2078 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
                return 103; /* truncdfsf2_cf */
              if (!
#line 2088 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
                return -1;
              return 104; /* *truncdfsf2_68881 */

            case E_XFmode:
              if (!general_operand (operands[1], E_XFmode)
                  || !
#line 6600 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
                return -1;
              return 411; /* truncxfsf2 */

            default:
              return -1;
            }

        case E_DFmode:
          if (!nonimmediate_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !general_operand (operands[1], E_XFmode)
              || !
#line 6585 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 410; /* truncxfdf2 */

        default:
          return -1;
        }

    case FLOAT:
      return recog_34 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_27 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_35 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_28 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_30 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_29 (x1, insn, pnum_clobbers);

    case SQRT:
      switch (pattern2 (x1))
        {
        case 0:
          if (
#line 4184 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 286; /* sqrtsf2_68881 */
          if (!
#line 4195 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 289; /* sqrtsf2_cf */

        case 1:
          if (
#line 4184 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 287; /* sqrtdf2_68881 */
          if (!
#line 4195 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 290; /* sqrtdf2_cf */

        case 2:
          if (!
#line 4184 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 288; /* sqrtxf2_68881 */

        default:
          return -1;
        }

    case ABS:
      switch (pattern2 (x1))
        {
        case 0:
          if (
#line 4299 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 291; /* abssf2_68881 */
          if (!
#line 4314 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 294; /* abssf2_cf */

        case 1:
          if (
#line 4299 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 292; /* absdf2_68881 */
          if (!
#line 4314 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 295; /* absdf2_cf */

        case 2:
          if (!
#line 4299 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 293; /* absxf2_68881 */

        default:
          return -1;
        }

    case CLZ:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (general_operand (operands[1], E_SImode)
          && 
#line 4341 "../../gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD))
        return 296; /* *clzsi2_68k */
      if (!register_operand (operands[1], E_SImode)
          || !
#line 4348 "../../gcc/config/m68k/m68k.md"
(ISA_HAS_FF1))
        return -1;
      return 297; /* *clzsi2_cf */

    case NOT:
      switch (pattern1 (x1))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !general_operand (operands[1], E_SImode))
                return -1;
              if (
#line 4369 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 298; /* one_cmplsi2_internal */
              if (!
#line 4376 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
                return -1;
              return 299; /* one_cmplsi2_5200 */

            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !general_operand (operands[1], E_HImode)
                  || !
#line 4383 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 300; /* one_cmplhi2 */

            case E_QImode:
              if (!nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !general_operand (operands[1], E_QImode)
                  || !
#line 4397 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 302; /* one_cmplqi2 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 4390 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 301; /* *m68k.md:4387 */

        case 2:
          if (!
#line 4404 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 303; /* *m68k.md:4401 */

        default:
          return -1;
        }

    case ASHIFT:
      return recog_31 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) == CONST_INT)
        {
          res = recog_24 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x4 = XEXP (x1, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (pattern5 (x1))
            {
            case 0:
              return 325; /* ashrsi3 */

            case 1:
              if (!
#line 4911 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 326; /* ashrhi3 */

            case 2:
              if (!
#line 4927 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 328; /* ashrqi3 */

            default:
              return -1;
            }

        case STRICT_LOW_PART:
          switch (pattern6 (x1))
            {
            case 0:
              if (!
#line 4919 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 327; /* *m68k.md:4915 */

            case 1:
              if (!
#line 4935 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 329; /* *m68k.md:4931 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      return recog_33 (x1, insn, pnum_clobbers);

    case ROTATE:
      if (GET_MODE (x2) == E_SImode)
        {
          x7 = XEXP (x2, 1);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 16])
            {
              x4 = XEXP (x1, 0);
              operands[0] = x4;
              if (register_operand (operands[0], E_SImode))
                {
                  x3 = XEXP (x2, 0);
                  operands[1] = x3;
                  if (register_operand (operands[1], E_SImode))
                    return 343; /* rotlsi_16 */
                }
            }
        }
      x4 = XEXP (x1, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (pattern5 (x1))
            {
            case 0:
              if (!
#line 5256 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 344; /* rotlsi3 */

            case 1:
              if (!
#line 5274 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 345; /* rotlhi3 */

            case 2:
              if (!
#line 5306 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 347; /* rotlqi3 */

            default:
              return -1;
            }

        case STRICT_LOW_PART:
          switch (pattern6 (x1))
            {
            case 0:
              if (!
#line 5290 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 346; /* *rotlhi3_lowpart */

            case 1:
              if (!
#line 5322 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 348; /* *rotlqi3_lowpart */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ROTATERT:
      x4 = XEXP (x1, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (pattern5 (x1))
            {
            case 0:
              if (!
#line 5338 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 349; /* rotrsi3 */

            case 1:
              if (!
#line 5346 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 350; /* rotrhi3 */

            case 2:
              if (!
#line 5360 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 352; /* rotrqi3 */

            default:
              return -1;
            }

        case STRICT_LOW_PART:
          switch (pattern6 (x1))
            {
            case 0:
              if (!
#line 5353 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 351; /* rotrhi_lowpart */

            case 1:
              if (!
#line 5368 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 353; /* *m68k.md:5364 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (nonimmediate_operand (operands[0], E_SImode))
        {
          res = recog_25 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!memory_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      if (!nonmemory_operand (operands[3], E_SImode)
          || !
#line 5625 "../../gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD))
        return -1;
      return 368; /* *extzv_bfextu_mem */

    case SIGN_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (nonimmediate_operand (operands[0], E_SImode))
        {
          res = recog_26 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!memory_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      if (!nonmemory_operand (operands[3], E_SImode)
          || !
#line 5609 "../../gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD))
        return -1;
      return 367; /* *extv_bfexts_mem */

    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      if (sibcall_operand (operands[1], E_SImode)
          && 
#line 5983 "../../gcc/config/m68k/m68k.md"
(SIBLING_CALL_P (insn)))
        return 391; /* *sibcall_value */
      if (non_symbolic_call_operand (operands[1], E_SImode)
          && 
#line 6026 "../../gcc/config/m68k/m68k.md"
(!SIBLING_CALL_P (insn)))
        return 393; /* *non_symbolic_call_value */
      if (!symbolic_operand (operands[1], E_SImode))
        return -1;
      if (
#line 6036 "../../gcc/config/m68k/m68k.md"
(!SIBLING_CALL_P (insn) && m68k_symbolic_call_var == M68K_SYMBOLIC_CALL_JSR))
        return 394; /* *symbolic_call_value_jsr */
      if (!
#line 6049 "../../gcc/config/m68k/m68k.md"
(!SIBLING_CALL_P (insn)
   && (m68k_symbolic_call_var == M68K_SYMBOLIC_CALL_BSR_C
       || m68k_symbolic_call_var == M68K_SYMBOLIC_CALL_BSR_P)))
        return -1;
      return 395; /* *symbolic_call_value_bsr */

    case UNSPEC:
      switch (XVECLEN (x2, 0))
        {
        case 1:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          switch (XINT (x2, 1))
            {
            case 3:
              if (GET_MODE (x2) != E_SImode)
                return -1;
              x11 = XVECEXP (x2, 0, 0);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !register_operand (operands[0], E_SImode))
                return -1;
              return 405; /* load_got */

            case 1:
              switch (pattern18 (x2))
                {
                case 0:
                  if (!
#line 6607 "../../gcc/config/m68k/m68k.md"
(TARGET_68881 && flag_unsafe_math_optimizations))
                    return -1;
                  return 412; /* sinsf2 */

                case 1:
                  if (!
#line 6607 "../../gcc/config/m68k/m68k.md"
(TARGET_68881 && flag_unsafe_math_optimizations))
                    return -1;
                  return 413; /* sindf2 */

                case 2:
                  if (!(
#line 6607 "../../gcc/config/m68k/m68k.md"
(TARGET_68881 && flag_unsafe_math_optimizations) && 
#line 278 "../../gcc/config/m68k/m68k.md"
(TARGET_68881)))
                    return -1;
                  return 414; /* sinxf2 */

                default:
                  return -1;
                }

            case 2:
              switch (pattern18 (x2))
                {
                case 0:
                  if (!
#line 6619 "../../gcc/config/m68k/m68k.md"
(TARGET_68881 && flag_unsafe_math_optimizations))
                    return -1;
                  return 415; /* cossf2 */

                case 1:
                  if (!
#line 6619 "../../gcc/config/m68k/m68k.md"
(TARGET_68881 && flag_unsafe_math_optimizations))
                    return -1;
                  return 416; /* cosdf2 */

                case 2:
                  if (!(
#line 6619 "../../gcc/config/m68k/m68k.md"
(TARGET_68881 && flag_unsafe_math_optimizations) && 
#line 278 "../../gcc/config/m68k/m68k.md"
(TARGET_68881)))
                    return -1;
                  return 417; /* cosxf2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          if (XINT (x2, 1) != 5
              || GET_MODE (x2) != E_BLKmode)
            return -1;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_BLKmode)
            return -1;
          x12 = XEXP (x4, 0);
          if (GET_CODE (x12) != SCRATCH)
            return -1;
          x11 = XVECEXP (x2, 0, 0);
          operands[0] = x11;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x13 = XVECEXP (x2, 0, 1);
          operands[1] = x13;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 425; /* stack_tie */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
