/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !general_operand (operands[1], i1)
      || !general_src_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern12 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern10 (x3, 
E_DImode) != 0)
        return -1;
      return 0;

    case E_HImode:
      if (pattern11 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_QImode:
      if (pattern11 (x3, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_SFmode:
      if (pattern10 (x3, 
E_SFmode) != 0)
        return -1;
      return 3;

    case E_DFmode:
      if (pattern10 (x3, 
E_DFmode) != 0)
        return -1;
      return 4;

    case E_XFmode:
      if (pattern10 (x3, 
E_XFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 2);
  if (!const_int_operand (x3, E_SImode))
    return -1;
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  if (XWINT (x4, 0) == 32L
      && memory_operand (operands[0], E_QImode))
    {
      x5 = XEXP (x1, 1);
      operands[2] = x5;
      if (general_src_operand (operands[2], E_SImode)
          && 
#line 5479 "../../gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD
   && (INTVAL (operands[1]) % 8) == 0
   && ! mode_dependent_address_p (XEXP (operands[0], 0),
                                  MEM_ADDR_SPACE (operands[0]))))
        return 361; /* *insv_32_mem */
    }
  operands[2] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  if (
#line 5495 "../../gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD
   && IN_RANGE (INTVAL (operands[2]), 0, 31)
   && (INTVAL (operands[1]) == 8 || INTVAL (operands[1]) == 16)
   && INTVAL (operands[2]) % INTVAL (operands[1]) == 0))
    return 362; /* *insv_8_16_reg */
  if (!
#line 5737 "../../gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD && IN_RANGE (INTVAL (operands[2]), 0, 31)))
    return -1;
  return 377; /* *insv_bfins_reg */
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (register_operand (operands[1], E_VOIDmode))
    {
      if (post_inc_operand (operands[0], E_VOIDmode)
          && 
#line 1693 "../../gcc/config/m68k/m68k.md"
(GET_MODE_CLASS (GET_MODE (operands[0])) == MODE_INT &&
   GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT &&
   GET_MODE_SIZE (GET_MODE (operands[0])) == GET_MODE_SIZE (GET_MODE (operands[1])) * 2))
        return 81; /* *zero_extend_inc */
      if (pre_dec_operand (operands[0], E_VOIDmode)
          && 
#line 1709 "../../gcc/config/m68k/m68k.md"
((GET_MODE (operands[0]) != HImode || XEXP (XEXP (operands[0], 0), 0) != stack_pointer_rtx) &&
   GET_MODE_CLASS (GET_MODE (operands[0])) == MODE_INT &&
   GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT &&
   GET_MODE_SIZE (GET_MODE (operands[0])) == GET_MODE_SIZE (GET_MODE (operands[1])) * 2))
        return 82; /* *zero_extend_dec */
    }
  if (nonimmediate_src_operand (operands[1], E_SImode)
      && nonimmediate_operand (operands[0], E_DImode)
      && GET_MODE (x2) == E_DImode
      && 
#line 1766 "../../gcc/config/m68k/m68k.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) != MEM))
    return 85; /* *zero_extendsidi2 */
  if (register_operand (operands[0], E_SImode)
      && GET_MODE (x2) == E_SImode)
    {
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (nonimmediate_src_operand (operands[1], E_HImode))
            {
              if (
#line 1781 "../../gcc/config/m68k/m68k.md"
(ISA_HAS_MVS_MVZ))
                return 86; /* *zero_extendhisi2_cf */
              return 87; /* zero_extendhisi2 */
            }
          break;

        case E_QImode:
          if (nonimmediate_src_operand (operands[1], E_QImode))
            {
              if (
#line 1806 "../../gcc/config/m68k/m68k.md"
(ISA_HAS_MVS_MVZ))
                return 89; /* *zero_extendqisi2_cfv4 */
              return 90; /* zero_extendqisi2 */
            }
          break;

        default:
          break;
        }
    }
  if (!nonimmediate_src_operand (operands[1], E_QImode)
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode
      || !
#line 1800 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
    return -1;
  return 88; /* *zero_extendqihi2 */
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern11 (x3, 
E_SImode) != 0)
        return -1;
      if (
#line 3778 "../../gcc/config/m68k/m68k.md"
(! TARGET_COLDFIRE))
        return 255; /* iorsi3_internal */
      if (!
#line 3788 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
        return -1;
      return 256; /* iorsi3_5200 */

    case E_HImode:
      if (pattern11 (x3, 
E_HImode) != 0
          || !
#line 3798 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
        return -1;
      return 257; /* iorhi3 */

    case E_QImode:
      if (pattern11 (x3, 
E_QImode) != 0
          || !
#line 3820 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
        return -1;
      return 260; /* iorqi3 */

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case FIX:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_DFmode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 2173 "../../gcc/config/m68k/m68k.md"
(TARGET_68881 && TUNE_68040))
            return -1;
          *pnum_clobbers = 2;
          return 120; /* fix_truncdfsi2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !
#line 2183 "../../gcc/config/m68k/m68k.md"
(TARGET_68881 && TUNE_68040))
            return -1;
          *pnum_clobbers = 2;
          return 121; /* fix_truncdfhi2 */

        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !
#line 2193 "../../gcc/config/m68k/m68k.md"
(TARGET_68881 && TUNE_68040))
            return -1;
          *pnum_clobbers = 2;
          return 122; /* fix_truncdfqi2 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !general_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 2210 "../../gcc/config/m68k/m68k.md"
(TARGET_68881 && !TUNE_68040))
            return 123; /* ftruncsf2_68881 */
          if (!
#line 2221 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 126; /* ftruncsf2_cf */

        case E_DFmode:
          if (!nonimmediate_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !general_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 2210 "../../gcc/config/m68k/m68k.md"
(TARGET_68881 && !TUNE_68040))
            return 124; /* ftruncdf2_68881 */
          if (!
#line 2221 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 127; /* ftruncdf2_cf */

        case E_XFmode:
          if (!nonimmediate_operand (operands[0], E_XFmode)
              || GET_MODE (x3) != E_XFmode
              || !general_operand (operands[1], E_XFmode)
              || !(
#line 2210 "../../gcc/config/m68k/m68k.md"
(TARGET_68881 && !TUNE_68040) && 
#line 278 "../../gcc/config/m68k/m68k.md"
(TARGET_68881)))
            return -1;
          return 125; /* ftruncxf2_68881 */

        case E_QImode:
          switch (pattern20 (x3, 
E_QImode))
            {
            case 0:
              if (
#line 2240 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
                return 128; /* fixsfqi2_68881 */
              if (!
#line 2247 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
                return -1;
              return 131; /* fixsfqi2_cf */

            case 1:
              if (
#line 2240 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
                return 129; /* fixdfqi2_68881 */
              if (!
#line 2247 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
                return -1;
              return 132; /* fixdfqi2_cf */

            case 2:
              if (!
#line 2240 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
                return -1;
              return 130; /* fixxfqi2_68881 */

            default:
              return -1;
            }

        case E_HImode:
          switch (pattern20 (x3, 
E_HImode))
            {
            case 0:
              if (
#line 2260 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
                return 133; /* fixsfhi2_68881 */
              if (!
#line 2267 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
                return -1;
              return 136; /* fixsfhi2_cf */

            case 1:
              if (
#line 2260 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
                return 134; /* fixdfhi2_68881 */
              if (!
#line 2267 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
                return -1;
              return 137; /* fixdfhi2_cf */

            case 2:
              if (!
#line 2260 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
                return -1;
              return 135; /* fixxfhi2_68881 */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern20 (x3, 
E_SImode))
            {
            case 0:
              if (
#line 2280 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
                return 138; /* fixsfsi2_68881 */
              if (!
#line 2287 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
                return -1;
              return 141; /* fixsfsi2_cf */

            case 1:
              if (
#line 2280 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
                return 139; /* fixdfsi2_68881 */
              if (!
#line 2287 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
                return -1;
              return 142; /* fixdfsi2_cf */

            case 2:
              if (!
#line 2280 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
                return -1;
              return 140; /* fixxfsi2_68881 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (memory_operand (operands[0], E_SImode)
      && const_int_operand (operands[1], E_SImode)
      && 
#line 6350 "../../gcc/config/m68k/m68k.md"
(GET_CODE (XEXP (operands[0], 0)) != PRE_DEC
   && INTVAL (operands[1]) != 0
   && IN_RANGE (INTVAL (operands[1]), -0x80, 0x7f)
   && !valid_mov3q_const (INTVAL (operands[1]))))
    {
      *pmatch_len_ = 0;
      res = gen_peephole2_5 (insn, operands);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 2
      || !register_operand (operands[0], E_SImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != SET)
    return NULL;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != IF_THEN_ELSE)
    return NULL;
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != PC)
    return NULL;
  x6 = XEXP (x4, 1);
  if (!pc_or_label_operand (x6, E_VOIDmode))
    return NULL;
  operands[3] = x6;
  if (addq_subq_operand (operands[1], E_SImode))
    {
      x7 = XEXP (x4, 0);
      if (equality_comparison_operator (x7, E_VOIDmode))
        {
          operands[5] = x7;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (register_operand (operands[2], E_SImode))
            {
              x9 = XEXP (x4, 2);
              operands[4] = x9;
              if (pc_or_label_operand (operands[4], E_VOIDmode))
                {
                  x10 = XEXP (x7, 1);
                  if (rtx_equal_p (x10, operands[0])
                      && 
#line 6771 "../../gcc/config/m68k/m68k.md"
(peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])
   && (operands[3] == pc_rtx || operands[4] == pc_rtx)
   && DATA_REG_P (operands[2])
   && !rtx_equal_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_14 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
        }
    }
  operands[4] = x6;
  if (!pow2_m1_operand (operands[1], E_SImode))
    return NULL;
  x9 = XEXP (x4, 2);
  operands[5] = x9;
  if (!pc_or_label_operand (operands[5], E_VOIDmode))
    return NULL;
  x7 = XEXP (x4, 0);
  switch (GET_CODE (x7))
    {
    case GTU:
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return NULL;
      x10 = XEXP (x7, 1);
      operands[3] = x10;
      if (!register_operand (operands[3], E_SImode)
          || !
#line 6789 "../../gcc/config/m68k/m68k.md"
(INTVAL (operands[1]) <= 255
   && operands[0] == operands[3]
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])
   && (operands[4] == pc_rtx || operands[5] == pc_rtx)
   && (optimize_size || TUNE_68040_60)
   && DATA_REG_P (operands[2])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_15 (insn, operands);

    case LEU:
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return NULL;
      x10 = XEXP (x7, 1);
      operands[3] = x10;
      if (!register_operand (operands[3], E_SImode)
          || !
#line 6827 "../../gcc/config/m68k/m68k.md"
(INTVAL (operands[1]) <= 255
   && operands[0] == operands[3]
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])
   && (operands[4] == pc_rtx || operands[5] == pc_rtx)
   && (optimize_size || TUNE_68040_60)
   && DATA_REG_P (operands[2])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_17 (insn, operands);

    default:
      return NULL;
    }
}
