/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x2, 0);
  operands[3] = x9;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern7 (x1, 
E_SImode); /* [-1, 0] */

    case E_HImode:
      if (pattern7 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!general_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!general_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_XFmode:
      if (!general_operand (operands[1], E_XFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) == CONST_INT)
    {
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (!memory_operand (operands[0], E_QImode))
    return -1;
  operands[1] = x4;
  if (!nonmemory_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode)
      || !
#line 5688 "../../gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD))
    return -1;
  return 372; /* *insv_bfins_mem */
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern11 (x3, 
E_HImode) != 0)
            return -1;
          return 196; /* mulhi3 */

        case E_DFmode:
          if (pattern10 (x3, 
E_DFmode) != 0)
            return -1;
          if (
#line 3393 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 220; /* muldf_68881 */
          if (!
#line 3435 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 224; /* fmuldf3_cf */

        case E_SFmode:
          if (pattern10 (x3, 
E_SFmode) != 0)
            return -1;
          if (
#line 3411 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 221; /* mulsf_68881 */
          if (!
#line 3435 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 223; /* fmulsf3_cf */

        case E_XFmode:
          if (!nonimmediate_operand (operands[0], E_XFmode)
              || GET_MODE (x3) != E_XFmode
              || !nonimmediate_operand (operands[1], E_XFmode)
              || !nonimmediate_operand (operands[2], E_XFmode)
              || !
#line 3426 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 222; /* mulxf3_68881 */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern14 (x3))
        {
        case 0:
          if (general_operand (operands[2], E_SImode)
              && 
#line 3354 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 211; /* mulsf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 3367 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 214; /* mulsf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 3380 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 217; /* mulsf3_floatqi_68881 */

        case 1:
          if (general_operand (operands[2], E_SImode)
              && 
#line 3354 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 212; /* muldf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 3367 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 215; /* muldf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 3380 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 218; /* muldf3_floatqi_68881 */

        case 2:
          if (general_operand (operands[2], E_SImode)
              && 
#line 3354 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 213; /* mulxf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 3367 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 216; /* mulxf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 3380 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 219; /* mulxf3_floatqi_68881 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (XWINT (x5, 0))
    {
    case 16L:
      if (register_operand (operands[0], E_SImode)
          && GET_MODE (x3) == E_SImode
          && register_operand (operands[1], E_SImode)
          && 
#line 4699 "../../gcc/config/m68k/m68k.md"
(!TUNE_68060))
        return 316; /* ashrsi_16 */
      break;

    case 1L:
      if (register_operand (operands[0], E_DImode)
          && GET_MODE (x3) == E_DImode
          && register_operand (operands[1], E_DImode)
          && 
#line 4742 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
        return 320; /* *ashrdi3_const1 */
      break;

    case 32L:
      if (GET_MODE (x3) == E_DImode
          && nonimmediate_src_operand (operands[1], E_DImode))
        {
          if (register_operand (operands[0], E_DImode))
            return 321; /* *ashrdi_const32 */
          if (pnum_clobbers != NULL
              && memory_operand (operands[0], E_DImode))
            {
              *pnum_clobbers = 1;
              return 322; /* *ashrdi_const32_mem */
            }
        }
      break;

    default:
      break;
    }
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern22 (x3) == 0
          && 
#line 4708 "../../gcc/config/m68k/m68k.md"
(TUNE_68000_10
   && INTVAL (operands[2]) > 16
   && INTVAL (operands[2]) <= 24))
        return 317; /* *m68k.md:4704 */
      break;

    case E_DImode:
      if (pattern23 (x3) == 0
          && 
#line 4848 "../../gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE
    && ((INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 3)
	|| INTVAL (operands[2]) == 8 || INTVAL (operands[2]) == 16
	|| INTVAL (operands[2]) == 31
	|| (INTVAL (operands[2]) > 32 && INTVAL (operands[2]) <= 63))))
        return 323; /* ashrdi_const */
      break;

    default:
      break;
    }
  if (!register_operand (operands[1], E_SImode)
      || XWINT (x5, 0) != 31L
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 324; /* ashrsi_31 */
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      if (general_operand (operands[1], E_SImode))
        {
          if (
#line 2109 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 105; /* floatsisf2_68881 */
          if (
#line 2116 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return 108; /* floatsisf2_cf */
        }
      if (general_operand (operands[1], E_HImode))
        {
          if (
#line 2130 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 110; /* floathisf2_68881 */
          if (
#line 2137 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return 113; /* floathisf2_cf */
        }
      if (!general_operand (operands[1], E_QImode))
        return -1;
      if (
#line 2151 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
        return 115; /* floatqisf2_68881 */
      if (!
#line 2158 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
        return -1;
      return 118; /* floatqisf2_cf */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      if (general_operand (operands[1], E_SImode))
        {
          if (
#line 2109 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 106; /* floatsidf2_68881 */
          if (
#line 2116 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return 109; /* floatsidf2_cf */
        }
      if (general_operand (operands[1], E_HImode))
        {
          if (
#line 2130 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 111; /* floathidf2_68881 */
          if (
#line 2137 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return 114; /* floathidf2_cf */
        }
      if (!general_operand (operands[1], E_QImode))
        return -1;
      if (
#line 2151 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
        return 116; /* floatqidf2_68881 */
      if (!
#line 2158 "../../gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
        return -1;
      return 119; /* floatqidf2_cf */

    case E_XFmode:
      if (!nonimmediate_operand (operands[0], E_XFmode)
          || GET_MODE (x3) != E_XFmode)
        return -1;
      if (general_operand (operands[1], E_SImode)
          && 
#line 2109 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
        return 107; /* floatsixf2_68881 */
      if (general_operand (operands[1], E_HImode)
          && 
#line 2130 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
        return 112; /* floathixf2_68881 */
      if (!general_operand (operands[1], E_QImode)
          || !
#line 2151 "../../gcc/config/m68k/m68k.md"
(TARGET_68881))
        return -1;
      return 117; /* floatqixf2_68881 */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (!scratch_operand (x5, E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case IF_THEN_ELSE:
      x7 = XEXP (x6, 0);
      if (!ordered_comparison_operator (x7, E_VOIDmode))
        return -1;
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x9 = XEXP (x6, 2);
      if (GET_CODE (x9) != PC)
        return -1;
      x10 = XEXP (x2, 0);
      if (GET_CODE (x10) != PC)
        return -1;
      x11 = XEXP (x7, 0);
      operands[2] = x11;
      if (!nonimmediate_operand (operands[2], E_DImode))
        return -1;
      x12 = XEXP (x7, 1);
      operands[3] = x12;
      if (!general_operand (operands[3], E_DImode))
        return -1;
      x13 = XEXP (x8, 0);
      operands[4] = x13;
      x14 = XEXP (x3, 0);
      operands[0] = x14;
      if (!scratch_operand (operands[0], E_DImode))
        return -1;
      operands[5] = x5;
      return 5; /* cbranchdi4_insn */

    case FIX:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != FIX
          || GET_MODE (x7) != E_DFmode)
        return -1;
      x10 = XEXP (x2, 0);
      operands[0] = x10;
      x11 = XEXP (x7, 0);
      operands[1] = x11;
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      x14 = XEXP (x3, 0);
      operands[2] = x14;
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !
#line 2173 "../../gcc/config/m68k/m68k.md"
(TARGET_68881 && TUNE_68040))
            return -1;
          return 120; /* fix_truncdfsi2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x6) != E_HImode
              || !
#line 2183 "../../gcc/config/m68k/m68k.md"
(TARGET_68881 && TUNE_68040))
            return -1;
          return 121; /* fix_truncdfhi2 */

        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || GET_MODE (x6) != E_QImode
              || !
#line 2193 "../../gcc/config/m68k/m68k.md"
(TARGET_68881 && TUNE_68040))
            return -1;
          return 122; /* fix_truncdfqi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
